using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;

namespace ListViewFixe
{
	/// <summary>
	/// Description rsume de Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// Variable ncessaire au concepteur.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Requis pour la prise en charge du Concepteur Windows Forms
			//
			InitializeComponent();

			//
			// TODO : ajoutez le code du constructeur aprs l'appel  InitializeComponent
			//

			RestrictedListView ListViewFixe = new RestrictedListView();

			ListViewFixe.Columns.Add("Colonne 1", -2, HorizontalAlignment.Center);
			ListViewFixe.Columns.Add("Colonne 2", -2, HorizontalAlignment.Center);
			ListViewFixe.Columns.Add("Colonne 3", -2, HorizontalAlignment.Center);

			ListViewItem item = new ListViewItem("test");
			ListViewFixe.Items.Add(item);

			ListViewFixe.View = View.Details;
			ListViewFixe.Height = 300;
			ListViewFixe.Width = 300;

			this.Controls.Add(ListViewFixe);
		}

		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Code gnr par le Concepteur Windows Form
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Name = "Form1";
			this.Text = "Form1";

		}
		#endregion

		/// <summary>
		/// Point d'entre principal de l'application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
	}

	public class RestrictedListView : ListView
	{
		public const int WM_NOTIFY = 0x4E;
		public const int HDN_FIRST = -300;
		public const int HDN_BEGINTRACKA = HDN_FIRST - 6;
		public const int HDN_BEGINTRACKW = HDN_FIRST - 26;

		[StructLayout(LayoutKind.Sequential)]
			public struct NMHDR
		{
			public int hwndFrom;
			public int idFrom;
			public int code;
		}

		protected override void WndProc(ref Message m)
		{
			switch (m.Msg)
			{
				case WM_NOTIFY:
				{
					NMHDR nmh = (NMHDR) m.GetLParam(typeof (NMHDR));
					if (nmh.code == HDN_BEGINTRACKA || nmh.code == HDN_BEGINTRACKW)
					{
						m.Result = new IntPtr(-1);
					}
				}
					break;

				default:
					base.WndProc (ref m);
					break;
			}
		}
	}
}
